LeetCode [267] Palindrome Permutation II


LIKE CODING: LeetCode [267] Palindrome Permutation II
 Given a string s, return all the palindromic permutations (without duplicates) of it. Return an empty list if no palindromic permutation could be form. 
For example: 
Given s = "aabb", return ["abba", "baab"]
Given s = "abc", return []
Hint:
If a palindromic permutation exists, we just need to generate the first half of the string.
To generate all distinct permutations of a (half of) string, use a similar approach from: Permutations II or Next Permutation.
https://discuss.leetcode.com/topic/30850/java-6ms-solution-no-reversal-or-concat
https://discuss.leetcode.com/topic/22204/my-accepted-java-solution
The idea is to start recursion from the mid position, and copy char to left and right in the char array in-place until we reach the left and right ends.
elegant!. preaclloc a buffer and use String(char[]) constructor!
one suggestion to make less parameter is : left value is enough, since right can be calculated from left.
// the idea is to build a count map for the chars in s
// and terminate if s cannot form a palindrome 
// then do DFS from the center until reaching the left/right end
// complexity: time O(n!), space O(n)
public List<String> generatePalindromes(String s) {
 List<String> result = new LinkedList<String>();
 if (s == null)
  return result;
 char[] array = s.toCharArray();
 Map<Character, Integer> map = new HashMap<Character, Integer>();
 for (int i = 0; i < array.length; i++) {
  char c = array[i];
  map.put(c, map.getOrDefault(c, 0) + 1);
 }
 Character odd = null;
 for (Map.Entry<Character, Integer> e : map.entrySet()) {
  if (e.getValue() % 2 == 1) { // odd
   if (odd != null) {
    return result;
   }
   if (array.length % 2 == 0) {
    return result;
   }
   odd = e.getKey();
  }
 }
 if (odd == null) { // s is of even length
  helper(array, result, map, array.length / 2 - 1, array.length / 2);
 } else { // odd length
  array[array.length / 2] = odd;
  map.put(odd, map.get(odd) - 1);
  helper(array, result, map, array.length / 2 - 1,
    array.length / 2 + 1);
 }
 return result;
}

private void helper(char[] array, List<String> result,
  Map<Character, Integer> map, int left, int right) {
 if (left == -1) {
  result.add(new String(array));
  return;
 }
 for (Map.Entry<Character, Integer> e : map.entrySet()) {
  if (e.getValue() >= 2) {
   e.setValue(e.getValue() - 2);
   array[left] = e.getKey();
   array[right] = e.getKey();
   helper(array, result, map, left - 1, right + 1);
   e.setValue(e.getValue() + 2);
  }
 }
}
public List<String> generatePalindromes(String s) {
    int odd = 0;
    String mid = "";
    List<String> res = new ArrayList<>();
    List<Character> list = new ArrayList<>();
    Map<Character, Integer> map = new HashMap<>();

    // step 1. build character count map and count odds
    for (int i = 0; i < s.length(); i++) {
        char c = s.charAt(i);
        map.put(c, map.containsKey(c) ? map.get(c) + 1 : 1);
        odd += map.get(c) % 2 != 0 ? 1 : -1;
    }

    // cannot form any palindromic string
    if (odd > 1) return res;

    // step 2. add half count of each character to list
    for (Map.Entry<Character, Integer> entry : map.entrySet()) {
        char key = entry.getKey();
        int val = entry.getValue();

        if (val % 2 != 0) mid += key;

        for (int i = 0; i < val / 2; i++) list.add(key);
    }

    // step 3. generate all the permutations
    getPerm(list, mid, new boolean[list.size()], new StringBuilder(), res);

    return res;
}

// generate all unique permutation from list
void getPerm(List<Character> list, String mid, boolean[] used, StringBuilder sb, List<String> res) {
    if (sb.length() == list.size()) {
        // form the palindromic string
        res.add(sb.toString() + mid + sb.reverse().toString());
        sb.reverse();//\\
        return;
    }

    for (int i = 0; i < list.size(); i++) {
        // avoid duplication
        if (i > 0 && list.get(i) == list.get(i - 1) && !used[i - 1]) continue;

        if (!used[i]) {
            used[i] = true; sb.append(list.get(i));
            // recursion
            getPerm(list, mid, used, sb, res);
            // backtracking
            used[i] = false; sb.deleteCharAt(sb.length() - 1);
        }
    }
}


https://discuss.leetcode.com/topic/28020/short-backtracking-solution-in-java-3-ms
https://discuss.leetcode.com/topic/22204/my-accepted-java-solution
We only need to generate the first part of palindrome string, and the remaining part will be a middle character with the reverse of first part.
private List<String> list = new ArrayList<>();

public List<String> generatePalindromes(String s) {
    int numOdds = 0; // How many characters that have odd number of count
    int[] map = new int[256]; // Map from character to its frequency
    for (char c: s.toCharArray()) {
        map[c]++;
        numOdds = (map[c] & 1) == 1 ? numOdds+1 : numOdds-1;
    }
    if (numOdds > 1)   return list;
    
    String mid = "";
    int length = 0;
    for (int i = 0; i < 256; i++) {
        if (map[i] > 0) {
            if ((map[i] & 1) == 1) { // Char with odd count will be in the middle
                mid = "" + (char)i;
                map[i]--;
            }
            map[i] /= 2; // Cut in half since we only generate half string
            length += map[i]; // The length of half string
        }
    }
    generatePalindromesHelper(map, length, "", mid);
    return list;
}
private void generatePalindromesHelper(int[] map, int length, String s, String mid) {
    if (s.length() == length) {
        StringBuilder reverse = new StringBuilder(s).reverse(); // Second half
        list.add(s + mid + reverse);
        return;
    }
    for (int i = 0; i < 256; i++) { // backtracking just like permutation
        if (map[i] > 0) {
            map[i]--;
            generatePalindromesHelper(map, length, s + (char)i, mid);
            map[i]++;
        } 
    }
}

http://likesky3.iteye.com/blog/2238818
先按照Palindrome Permutation 的方法判断输入字符串 s 能否排列成为一个回文串。通过检查开始构造过程,有两个思路: 
思路1:按照leetcode的提示,我们仅需构造回文的前半部分。先利用前面判断过程中的map获得回文前半部分所有的字符,
相同字符排列在一起,然后按照Permutation II一题的思路获得前半部分所有的排列情况,最后组合回文的前后部分加入结果集。 
思路2:从中间往两端递归构造回文串。 
  1.     // Method 1  
  2.     public List<String> generatePalindromes(String s) {  
  3.         List<String> ret = new ArrayList<String>();  
  4.         if (s == null || s.length() == 0return ret;  
  5.         if (s.length() == 1) {ret.add(s); return ret;}  
  6.         int[] map = new int[256];  
  7.         for (int i = 0; i < s.length(); i++)  
  8.             map[s.charAt(i)]++;  
  9.         int oddCount = 0;  
  10.         int oddIdx = -1;  
  11.         StringBuilder half = new StringBuilder();  
  12.         for (int i = 0; i < 256; i++) {  
  13.             if ((map[i] & 1) == 1) {  
  14.                 oddIdx = i;  
  15.                 oddCount++;  
  16.                 if (oddCount == 2return ret;  
  17.             }  
  18.             int halfCount = map[i] / 2;  
  19.             for (int j = 0; j < halfCount; j++)  
  20.                 half.append((char)i);  
  21.         }  
  22.         List<String> halfPermutation = new ArrayList<String>();  
  23.         getPermutation(half.toString().toCharArray(), new boolean[half.length()], new StringBuilder(), halfPermutation);  
  24.         for (String curr : halfPermutation) {  
  25.             StringBuilder curr2 = new StringBuilder(curr);  
  26.             if (oddIdx != -1)  
  27.                 curr += (char)oddIdx;  
  28.             ret.add(curr + curr2.reverse().toString());   
  29.         }  
  30.         return ret;  
  31.     }  
  32.       
  33.     public void getPermutation(char[] chars, boolean[] used, StringBuilder item, List<String> result) {  
  34.         if (item.length() == chars.length) {  
  35.             result.add(item.toString());  
  36.         } else {  
  37.             for (int i = 0; i < chars.length; i++) {  
  38.                 if (used[i] || (i > 0 && chars[i] == chars[i - 1] && !used[i - 1]))  
  39.                     continue;  
  40.                 item.append(chars[i]);  
  41.                 used[i] = true;  
  42.                 getPermutation(chars, used, item, result);  
  43.                 used[i] = false;  
  44.                 item.deleteCharAt(item.length() - 1);  
  45.             }  
  46.         }  
  47.     }  
  48.     // Method 2  
  49.     public List<String> generatePalindromes2(String s) {  
  50.         List<String> ret = new ArrayList<String>();  
  51.         int[] map = new int[256];  
  52.         for (int i = 0; i < s.length(); i++)  
  53.             map[s.charAt(i)]++;  
  54.         int oddCount = 0;  
  55.         int oddIdx = -1;  
  56.         for (int i = 0; i < 256; i++) {  
  57.             if ((map[i] & 1) == 1) {  
  58.                 oddIdx = i;  
  59.                 oddCount++;  
  60.                 if (oddCount == 2return ret;  
  61.             }  
  62.         }  
  63.         String curr = "";  
  64.         if (oddIdx != -1) {  
  65.             curr += (char)oddIdx;  
  66.             map[oddIdx]--;  
  67.         }  
  68.         dfs(curr, map, s.length(), ret);  
  69.         return ret;  
  70.     }  
  71.     public void dfs(String curr, int[] map, int n, List<String> ret) {  
  72.         if (curr.length() < n) {  
  73.             for (int i = 0; i < map.length; i++) {  
  74.                 if (map[i] > 0) {  
  75.                     curr = (char)i + curr + (char)i;  
  76.                     map[i] -= 2;  
  77.                     dfs(curr, map, n, ret);  
  78.                     curr = curr.substring(1, curr.length() - 1);  
  79.                     map[i] += 2;  
  80.                 }  
  81.             }  
  82.         } else {  
  83.             ret.add(curr);  
  84.         }  
  85.     }  
  86. }  

private List<String> list = new ArrayList<>(); public List<String> generatePalindromes(String s) { int numOdds = 0; // How many characters that have odd number of count int[] map = new int[256]; // Map from character to its frequency for (char c: s.toCharArray()) { map[c]++; numOdds = (map[c] & 1) == 1 ? numOdds+1 : numOdds-1; } if (numOdds > 1) return list; String mid = ""; int length = 0; for (int i = 0; i < 256; i++) { if (map[i] > 0) { if ((map[i] & 1) == 1) { // Char with odd count will be in the middle mid = "" + (char)i; map[i]--; } map[i] /= 2; // Cut in half since we only generate half string length += map[i]; // The length of half string } } generatePalindromesHelper(map, length, "", mid); return list; } private void generatePalindromesHelper(int[] map, int length, String s, String mid) { if (s.length() == length) { StringBuilder reverse = new StringBuilder(s).reverse(); // Second half list.add(s + mid + reverse); return; } for (int i = 0; i < 256; i++) { // backtracking just like permutation if (map[i] > 0) { map[i]--; generatePalindromesHelper(map, length, s + (char)i, mid); map[i]++; } } }
public List<String> generatePalindromes(String s) { List<String> result = new LinkedList<String>(); if (s == null) return result; char[] array = s.toCharArray(); Map<Character, Integer> map = new HashMap<Character, Integer>(); for (int i = 0; i < array.length; i++) { char c = array[i]; map.put(c, map.getOrDefault(c, 0) + 1); } Character odd = null; for (Map.Entry<Character, Integer> e : map.entrySet()) { if (e.getValue() % 2 == 1) { // odd if (odd != null) { return result; } if (array.length % 2 == 0) { return result; } odd = e.getKey(); } } if (odd == null) { // s is of even length helper(array, result, map, array.length / 2 - 1, array.length / 2); } else { // odd length array[array.length / 2] = odd; map.put(odd, map.get(odd) - 1); helper(array, result, map, array.length / 2 - 1, array.length / 2 + 1); } return result; } private void helper(char[] array, List<String> result, Map<Character, Integer> map, int left, int right) { if (left == -1) { result.add(new String(array)); return; } for (Map.Entry<Character, Integer> e : map.entrySet()) { if (e.getValue() >= 2) { e.setValue(e.getValue() - 2); array[left] = e.getKey(); array[right] = e.getKey(); helper(array, result, map, left - 1, right + 1); e.setValue(e.getValue() + 2); } } }
https://discuss.leetcode.com/topic/30850/java-6ms-solution-no-reversal-or-concat/2
public List<String> generatePalindromes(String s) {
 List<String> result = new LinkedList<String>();
 if (s == null)
  return result;
 char[] array = s.toCharArray();
 Map<Character, Integer> map = new HashMap<Character, Integer>();
 for (int i = 0; i < array.length; i++) {
  char c = array[i];
  map.put(c, map.getOrDefault(c, 0) + 1);
 }
 Character odd = null;
 for (Map.Entry<Character, Integer> e : map.entrySet()) {
  if (e.getValue() % 2 == 1) { // odd
   if (odd != null) {
    return result;
   }
   if (array.length % 2 == 0) {
    return result;
   }
   odd = e.getKey();
  }
 }
 if (odd == null) { // s is of even length
  helper(array, result, map, array.length / 2 - 1, array.length / 2);
 } else { // odd length
  array[array.length / 2] = odd;
  map.put(odd, map.get(odd) - 1);
  helper(array, result, map, array.length / 2 - 1,
    array.length / 2 + 1);
 }
 return result;
}

private void helper(char[] array, List<String> result,
  Map<Character, Integer> map, int left, int right) {
 if (left == -1) {
  result.add(new String(array));
  return;
 }
 for (Map.Entry<Character, Integer> e : map.entrySet()) {
  if (e.getValue() >= 2) {
   e.setValue(e.getValue() - 2);
   array[left] = e.getKey();
   array[right] = e.getKey();
   helper(array, result, map, left - 1, right + 1);
   e.setValue(e.getValue() + 2);
  }
 }

https://leetcode.com/discuss/53626/ac-java-solution-with-explanation
public List<String> generatePalindromes(String s) {
int odd = 0; String mid = ""; List<String> res = new ArrayList<>(); List<Character> list = new ArrayList<>(); Map<Character, Integer> map = new HashMap<>(); // step 1. build character count map and count odds for (int i = 0; i < s.length(); i++) { char c = s.charAt(i); map.put(c, map.containsKey(c) ? map.get(c) + 1 : 1); odd += map.get(c) % 2 != 0 ? 1 : -1; } // cannot form any palindromic string if (odd > 1) return res; // step 2. add half count of each character to list for (Map.Entry<Character, Integer> entry : map.entrySet()) { char key = entry.getKey(); int val = entry.getValue(); if (val % 2 != 0) mid += key; for (int i = 0; i < val / 2; i++) list.add(key); } // step 3. generate all the permutations getPerm(list, mid, new boolean[list.size()], new StringBuilder(), res); return res; } // generate all unique permutation from list void getPerm(List<Character> list, String mid, boolean[] used, StringBuilder sb, List<String> res) { if (sb.length() == list.size()) { // form the palindromic string res.add(sb.toString() + mid + sb.reverse().toString()); sb.reverse(); return; } for (int i = 0; i < list.size(); i++) { // avoid duplication if (i > 0 && list.get(i) == list.get(i - 1) && !used[i - 1]) continue; if (!used[i]) { used[i] = true; sb.append(list.get(i)); // recursion getPerm(list, mid, used, sb, res); // backtracking used[i] = false; sb.deleteCharAt(sb.length() - 1); } } }

public class Solution {
    public List<String> generatePalindromes(String s) {
        List<String> result = new ArrayList<>();
        if (s == null || s.length() == 0) {
            return result;
        }
         
        // Step 1: determine if the string s is palindrome permutated
        Map<Character, Integer> map = new HashMap();
        if (!isPalindromePermutation(s, map)) {
            return result;
        }
         
        // Step 2: form the left half of the seed string
        StringBuffer sb = new StringBuffer();
        char middle = '\0';
         
        Iterator it = map.entrySet().iterator();
        while (it.hasNext()) {
            Map.Entry pair = (Map.Entry) it.next();
            char key = (char) pair.getKey();
            int val = (int) pair.getValue();
            while (val > 1) {
                sb.append(key);
                val -= 2;
            }
             
            if (val == 1) {
                middle = key;
            }
        }
         
        // Step 3: gnerate the permutations of the string
        permutation(sb.toString().toCharArray(), 0, result);
        List<String> result2 = new ArrayList<>();
         
        // Step 4: append the right half of the string
        for (String str : result) {
            StringBuffer tmp = new StringBuffer(str);
            if (middle != '\0') {
                tmp.append(middle);
            }
             
            for (int i = str.length() - 1; i >= 0; i--) {
                tmp.append(str.charAt(i));
            }
            result2.add(tmp.toString());
        }
         
        return result2;
    }
     
    private boolean isPalindromePermutation(String s, Map<Character, Integer> map) {
        int tolerance = 0;
        for (int i = 0; i < s.length(); i++) {
            char c = s.charAt(i);
            if (map.containsKey(c)) {
                int val = map.get(c);
                map.put(c, val + 1);
            } else {
                map.put(c, 1);
            }
        }
         
        Iterator it = map.entrySet().iterator();
        while (it.hasNext()) {
            Map.Entry pair = (Map.Entry) it.next();
            int val = (int) pair.getValue();
            if (val % 2 == 1) {
                tolerance++;
            }
        }
         
        if (tolerance <= 1) {
            return true;
        } else {
            return false;
        }
    }
     
    private void permutation(char[] s, int start, List<String> result) {
        if (start >= s.length) {
            result.add(new String(s));
            return;
        }
         
        for (int i = start; i < s.length; i++) {
            if (!containsDuplicate(s, start, i)) {
                swap(s, i, start);
                permutation(s, start + 1, result);
                swap(s, i, start);
            }
        }
    }
     
    private void swap(char[] s, int i, int j) {
        char temp = s[i];
        s[i] = s[j];
        s[j] = temp;
    }
     
    private boolean containsDuplicate(char[] s, int start, int end) {
        for (int i = start; i < end; i++) {
            if (s[i] == s[end]) {
                return true;
            }
        }
         
        return false;
    }

}

    //compute unique permutations of the first half palindrom
    void bt(string halfs, int n, int pos, vector<string> &ret, int odd_cnt, char odd_char){
        if(pos==n){
            string rev = halfs;
            reverse(rev.begin(), rev.end());
            if(odd_cnt) halfs += odd_char;
            ret.push_back(halfs+rev);
        }else{
            for(int i=pos; i<n; ++i){
                if(i>pos && halfs[i]==halfs[pos]) continue;
                swap(halfs[i], halfs[pos]);
                bt(halfs, n, pos+1, ret, odd_cnt, odd_char);
            }
        }
    }
    //compute first half of palindrome
    string getHalfS(unordered_map<char, int> &hash, char &odd_char){
        string halfs;
        for(auto h:hash){
            if(h.second%2==1){
                odd_char = h.first;
                h.second--;
            }
            for(int i=0; i<h.second/2; ++i){
                halfs += h.first;
            }
        }
        return halfs;
    }
    //compute the count of odd characters in string,
    //if it is greater than 1, there's no palindrome permutaion
    int getOddCnt(string s, unordered_map<char, int> &hash){
        int odd_cnt = 0;
        for(auto c:s){
            hash[c]++;
            if(hash[c]%2==1){
                odd_cnt++;
            }else{
                odd_cnt--;
            }
        }
        return odd_cnt;
    }
    vector<string> generatePalindromes(string s) {
        vector<string> ret;
        unordered_map<char, int> hash;
        int odd_cnt = getOddCnt(s, hash);
        if(odd_cnt>1) return ret;
        char odd_char;
        string halfs = getHalfS(hash, odd_char);
        bt(halfs, halfs.size(), 0, ret, odd_cnt, odd_char);
        return ret;
    }
http://leetcode0.blogspot.com/2016/01/267-palindrome-permutation-ii.html
    public List<String> generatePalindromes(String s) {
        Map<Character,Integer> map = new HashMap<Character,Integer>();
        for(int i =0;i<s.length();i++){
            char ch = s.charAt(i);
            map.put(ch,   map.containsKey(ch) ? map.get(ch)+1 : 1  );
        }
        return helper(map);
    }
    private List<String> helper(Map<Character,Integer> map){
        List<String> list = new LinkedList<String>();
        // declare new LinkedList to avoid ConcurrentModificationException
        for(Character ch : new LinkedList<Character>(map.keySet())){
            int count = map.get(ch);
            if(map.size()==1){// only one char, we can use
                char[] tmp = new char[count];
                Arrays.fill(tmp,ch);
                list.add(new String(tmp));
                return list;
            }
            if(count == 1) // if all odd #, will get an empy list
                continue;
            map.put(ch,count-2);
            if(count == 2)
                map.remove(ch);
            List<String> lessList = helper(map);
            for(String str : lessList)
                list.add(""+ch+str+ch);
            map.put(ch,count);
        }
        return list;
    }
  1. 观察原因,应该是过多生成了新的Set()对象??????????????
  2. 每次都是旧的String + 新String,这样导致,要生成一个String with length n, we need  O(n^2) space and time complexity to 

网上的解法,利用了一个char[] array,  来记录每次的变化。
http://blog.csdn.net/pointbreak1/article/details/48779125
Follow up
http://www.1point3acres.com/bbs/thread-209202-1-1.html
longest palindrome string from a give string, 比如“atatdc",可以返回”atdta" /"tadat"/"atcta"/"tacat",这个题目需要返回所有可能的结果。

Read full article from LIKE CODING: LeetCode [267] Palindrome Permutation II

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts